## avogadro 1.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9)
project(Avogadro) # the name of your project

# The Avogadro version number, currently used by the Avogadro library too
set(Avogadro_VERSION_MAJOR 1)
set(Avogadro_VERSION_MINOR 2)
set(Avogadro_VERSION_PATCH 0)
set(Avogadro_VERSION "${Avogadro_VERSION_MAJOR}.${Avogadro_VERSION_MINOR}")
set(Avogadro_VERSION_FULL "${Avogadro_VERSION}.${Avogadro_VERSION_PATCH}")

set(CMAKE_MODULE_PATH ${Avogadro_SOURCE_DIR}/cmake/modules)

cmake_policy(SET CMP0003 NEW)

# this is adapted from KDE's FindKDE4Internal.cmake : default the build type to
# "release with debug info".
#
# We will define two other build types: Debug and Release.
# These names are case-insensitive i.e. you can do -DCMAKE_BUILD_TYPE=debug
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()
message(STATUS "The build type is ${CMAKE_BUILD_TYPE}")

include(CheckCXXCompilerFlag)
include(MacroEnsureVersion)
include(TestIfWeNeedFPermissive)

# use mulithreaded dll runtime on windows when using MSVC
if (MSVC)
  # Make sure the build is parallelised for faster builds
  set(CMAKE_CXX_FLAGS"${CMAKE_CXX_FLAGS} /MP")
  # Do not generate manifests for the plugins - caused issues loading plugins
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /MANIFEST:NO")
endif()

###########################################################
# Here I am adding GCC magic from KDE. With these settings#
# compiler issues are fixed and more warnings are issued. #
###########################################################
# We should always respect the users CXXFLAGS if they have set them
if (CMAKE_COMPILER_IS_GNUCXX)
  set (CMAKE_CXX_FLAGS_WARN "-Wnon-virtual-dtor -Wno-long-long -ansi -Wcast-align -Wchar-subscripts -Wall -Wextra -Wpointer-arith -Wformat-security -fno-check-new -fno-common -pedantic")
  # On Linux with GCC 4.3+ these flags generate thousands of warnings, so they
  # are now optional. Most of the warnings are in included headers.
  option(EXTRA_WARNINGS
    "Enable extra GCC warnings - can generate thousands" OFF)
  if(EXTRA_WARNINGS)
    # Enable extra compiler warnings for extra checking
    set (CMAKE_CXX_FLAGS_WARN "${CMAKE_CXX_FLAGS_WARN} -Wconversion -Woverloaded-virtual -Wfloat-equal")
#  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wshadow -Wold-style-cast")
  endif()
  add_definitions (-D_BSD_SOURCE)
  # Set some linker flags
  if(CMAKE_SYSTEM_NAME MATCHES Linux)
    set(CMAKE_SHARED_LINKER_FLAGS
      "-Wl,--fatal-warnings -Wl,--no-undefined -lc ${CMAKE_SHARED_LINKER_FLAGS}")
    set(CMAKE_SHARED_LINKER_FLAGS
      "-Wl,--enable-new-dtags ${CMAKE_SHARED_LINKER_FLAGS}")
    set(CMAKE_MODULE_LINKER_FLAGS
      "-Wl,--fatal-warnings -Wl,--no-undefined -lc ${CMAKE_SHARED_LINKER_FLAGS}")
    set(CMAKE_MODULE_LINKER_FLAGS
      "-Wl,--enable-new-dtags ${CMAKE_SHARED_LINKER_FLAGS}")
    set (CMAKE_EXE_LINKER_FLAGS
      "-Wl,--fatal-warnings -Wl,--no-undefined -lc ${CMAKE_SHARED_LINKER_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS
      "-Wl,--enable-new-dtags ${CMAKE_EXE_LINKER_FLAGS}")
  endif()
  # Now check if we can use visibility to selectively export symbols
  # Get the GCC version - from KDE4 cmake files
  exec_program(${CMAKE_C_COMPILER} ARGS --version OUTPUT_VARIABLE	_gcc_version_info)
  string (REGEX MATCH "[345]\\.[0-9]\\.[0-9]" _gcc_version "${_gcc_version_info}")
  # gcc on mac just reports: "gcc (GCC) 3.3 20030304 ..." without the
  # patch level, handle this here:
  if (NOT _gcc_version)
    string (REGEX REPLACE ".*\\(GCC\\).* ([34]\\.[0-9]) .*" "\\1.0" _gcc_version "${_gcc_version_info}")
  endif ()

  # No RTTI flag
  check_cxx_compiler_flag(-fno-rtti HAVE_NO_RTTI)
  if(HAVE_NO_RTTI)
    set(NO_RTTI_FLAG "-fno-rtti")
    # RTTI flag
    check_cxx_compiler_flag(-frtti HAVE_RTTI)
    if(HAVE_RTTI)
      set(RTTI_FLAG "-frtti")
    else()
      set(RTTI_FLAG "")
    endif()
  else()
    set(NO_RTTI_FLAG "")
    set(RTTI_FLAG "")
  endif()

  if(NOT APPLE) # Mac GCC42 compiler has bug
    check_cxx_compiler_flag(-fvisibility=hidden HAVE_GCC_VISIBILITY)
    set(HAVE_GCC_VISIBILITY ${HAVE_GCC_VISIBILITY} CACHE BOOL "GCC support for hidden visibility")
    macro_ensure_version("4.1.0" "${_gcc_version}" GCC_IS_NEWER_THAN_4_1)
    macro_ensure_version("4.2.0" "${_gcc_version}" GCC_IS_NEWER_THAN_4_2)
    set(_GCC_COMPILED_WITH_BAD_ALLOCATOR FALSE)
    if (GCC_IS_NEWER_THAN_4_1)
      exec_program(${CMAKE_C_COMPILER} ARGS -v OUTPUT_VARIABLE _gcc_alloc_info)
      string(REGEX MATCH "(--enable-libstdcxx-allocator=mt)" _GCC_COMPILED_WITH_BAD_ALLOCATOR "${_gcc_alloc_info}")
    endif ()

    if (HAVE_GCC_VISIBILITY AND GCC_IS_NEWER_THAN_4_1 AND NOT _GCC_COMPILED_WITH_BAD_ALLOCATOR)
      # We have all the parts necessary - use visibility support
      add_definitions(-DHAVE_GCC_VISIBILITY)
      set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
      if (GCC_IS_NEWER_THAN_4_2)
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
      endif()
    endif()
  endif()
  # Set up additional build flags for particular build types. These will be added to CMAKE_CXX_FLAGS,
  # they will not replace them.
  set(CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG -DQT_NO_DEBUG_OUTPUT -Wl,-s")
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO
    "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} ${CMAKE_CXX_FLAGS_WARN}")
  set(CMAKE_CXX_FLAGS_DEBUG   "-g3 -fno-inline ${CMAKE_CXX_FLAGS_WARN}")

  TEST_IF_WE_NEED_FPERMISSIVE(NEED_FPERMISSIVE)
  if(NEED_FPERMISSIVE)
    #OK, adding -fpermissive to the C++ compiler flags
    #Workaround for a problem with Boost.Python and GCC >= 4.3.1
    #Further information: cmake/modules/TestIfWeNeedFPermissive.cmake
    set (CMAKE_CXX_FLAGS   "${CMAKE_CXX_FLAGS} -fpermissive")
  endif()

  # define WITH_SSE2 to enable the SSE2 instruction set.
  # Available on Pentium 4, Athlon 64, and newer CPUs.
  # Enabled by default on the x86_64 architecture, but not on the x86 architecture.
  # If SSE2 is enabled, Eigen uses it by default; this can be disabled by
  # definining EIGEN_DONT_VECTORIZE.
  if(WITH_SSE2)
    message(STATUS "Enabling the SSE2 instruction set")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
  endif()
endif()


# Intel C++ Compiler
# Note: Windows version uses different options!
if(${CMAKE_CXX_COMPILER_ID} MATCHES Intel AND UNIX)
  # Disable warnings:
  # 981 - operands are evaluated in unspecified order
  # 1599 - foreach
  set (CMAKE_CXX_FLAGS_WARN "-Wnon-virtual-dtor -ansi -Wcheck -Wall -Wpointer-arith -wd981,1599")
  option(EXTRA_WARNINGS
    "Enable extra Intel Compiler warnings and remarks" OFF)
  if(EXTRA_WARNINGS)
    # Enable extra compiler warnings for extra checking
    set (CMAKE_CXX_FLAGS_WARN "${CMAKE_CXX_FLAGS_WARN} -w2 -Weffc++ -wd2012,2015")
  else()
    # 810 - conversion to float
    # 383 - value copied to temporary, reference to temporary used
    # 1418 - external function definition with no prior declaration
    set (CMAKE_CXX_FLAGS_WARN "${CMAKE_CXX_FLAGS_WARN} -wd383,810,1418")
  endif()
  add_definitions (-D_BSD_SOURCE)
  # Set some linker flags
  if(CMAKE_SYSTEM_NAME MATCHES Linux)
    set(CMAKE_SHARED_LINKER_FLAGS
      "-lc ${CMAKE_SHARED_LINKER_FLAGS}")
    set(CMAKE_MODULE_LINKER_FLAGS
      "-lc ${CMAKE_MODULE_LINKER_FLAGS}")
    set (CMAKE_EXE_LINKER_FLAGS
      "-lc ${CMAKE_EXE_LINKER_FLAGS}")
  endif()

  # No RTTI flag
  check_cxx_compiler_flag(-fno-rtti HAVE_NO_RTTI)
  if(HAVE_NO_RTTI)
    set(NO_RTTI_FLAG "-fno-rtti")
    # RTTI flag
    check_cxx_compiler_flag(-frtti HAVE_RTTI)
    if(HAVE_RTTI)
      set(RTTI_FLAG "-frtti")
    else()
      set(RTTI_FLAG "")
    endif()
  else()
    set(NO_RTTI_FLAG "")
    set(RTTI_FLAG "")
  endif()

  check_cxx_compiler_flag(-fvisibility=hidden HAVE_INTEL_VISIBILITY)
  set(HAVE_INTEL_VISIBILITY ${HAVE_INTEL_VISIBILITY} CACHE BOOL "Intel Compiler support for hidden visibility")
  if(HAVE_INTEL_VISIBILITY)
    add_definitions(-DHAVE_GCC_VISIBILITY)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
    check_cxx_compiler_flag(-fvisibility-inlines-hidden HAVE_INTEL_VISIBILITY_INLINES)
    set(HAVE_INTEL_VISIBILITY_INLINES ${HAVE_INTEL_VISIBILITY_INLINES} CACHE BOOL "Intel Compiler support for -fvisibility-inlines-hidden")
    if(HAVE_INTEL_VISIBILITY_INLINES)
      set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
    endif()
  endif()

  set(CMAKE_C_FLAGS_RELEASE "-O3 -ipo1 -DNDEBUG -DQT_NO_DEBUG_OUTPUT -Wl,-s")
  set(CMAKE_CXX_FLAGS_RELEASE "-O3 -ipo1 -DNDEBUG -DQT_NO_DEBUG_OUTPUT -Wl,-s")

  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO
    "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} ${CMAKE_CXX_FLAGS_WARN}")
  set(CMAKE_CXX_FLAGS_DEBUG   "-g3 -fno-inline ${CMAKE_CXX_FLAGS_WARN}")

  TEST_IF_WE_NEED_FPERMISSIVE(NEED_FPERMISSIVE)
  if(NEED_FPERMISSIVE)
    #OK, adding -fpermissive to the C++ compiler flags
    #Workaround for a problem with Boost.Python and GCC >= 4.3.1
    #Further information: cmake/modules/TestIfWeNeedFPermissive.cmake
    set (CMAKE_CXX_FLAGS   "${CMAKE_CXX_FLAGS} -fpermissive")
  endif()

  # define WITH_SSE2 to enable the SSE2 instruction set.
  # Available on Pentium 4, Athlon 64, and newer CPUs.
  # If SSE2 is enabled, Eigen uses it by default; this can be disabled by
  # definining EIGEN_DONT_VECTORIZE.
  if(CMAKE_SIZEOF_VOID_P EQUAL 8 OR WITH_SSE2)
    message(STATUS "Enabling the SSE2 instruction set")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
  endif()
endif()

set(I18N_LANGUAGE "" CACHE STRING "Build i18n only for selected language")

find_package(Qt4 4.6.0 REQUIRED) # find and setup Qt4 for this project
find_package(OpenGL REQUIRED) # find and setup OpenGL
find_package(X11) # find and setup X11 (not required for Mac and Windows)
find_package(Linguist) # find and setup Linguist
if(NOT Linguist_FOUND)
  message(WARNING " Qt4 Linguist not found, please install it if you want Avogadro translations")
endif()

find_package(Eigen3) # find and setup Eigen3 if available
if(NOT EIGEN3_FOUND)
   message(STATUS "Cannot find Eigen3, trying Eigen2")
   find_package(Eigen2 REQUIRED) # Some version is required
else()
# Use Stage10 Eigen3 support
   set (EIGEN2_SUPPORT_STAGE10_FULL_EIGEN2_API TRUE)
endif()

find_package(ZLIB REQUIRED)
find_package(OpenBabel2 REQUIRED) # find and setup OpenBabel

if (Q_WS_X11)
  find_package(X11 REQUIRED) # avogadro/src/main.cpp calls XInitThread().
endif()

# Check if we are building from a Git clone or a released version
function(git_version dir version_var)
  # Function to figure out the Git short version hash
  if(EXISTS ${dir}/.git)
    execute_process(COMMAND git rev-parse --short HEAD
            WORKING_DIRECTORY ${dir}
            OUTPUT_VARIABLE var)
    string(REGEX REPLACE "\n" "" var "${var}")
    message(STATUS "Git revision found to be ${var}")
    set(${version_var} "${var}" PARENT_SCOPE)
  endif(EXISTS ${dir}/.git)
endfunction()

git_version(${CMAKE_SOURCE_DIR} SCM_REVISION)
message(STATUS "Found Git revision is: ${SCM_REVISION}")
if(SCM_REVISION)
  message(STATUS "Building development version from Git clone.")
else()
  message(STATUS "Building released version.")
endif()

###########################################################
# Python Support: Detect and report all stuff here.       #
# Subdirectories can use: ALL_PYTHON_FOUND                #
###########################################################
option(ENABLE_PYTHON "Enable python support" ON)
if(ENABLE_PYTHON)
  include(PythonDeps)
  if(ALL_PYTHON_FOUND)
    message(STATUS "All python dependencies found - Python support enabled")
  else()
    set(ENABLE_PYTHON FALSE)
    message(WARNING "Not all python dependencies are found - Python support disabled")
  endif()
else()
  message(STATUS "Python support disabled.")
endif()

# Unit testing, mainly useful for developers and so defaults to off
option(ENABLE_TESTS "Enable unit testing" OFF)
if(ENABLE_TESTS)
  set(QT_USE_QTTEST TRUE)
  enable_testing()
  include (CTest)
  message(STATUS "Unit testing enabled, run make test to run them")
endif()

=== avogadro/CMakeLists.txt ===
project(avogadro)

if(WIN32)
  add_definitions( -DWIN32 )
  # add definitions for OB in WIN32
  add_definitions( -DUSING_OBDLL -DUSING_DYNAMIC_LIBS )
endif()

# tell cmake to process CMakeLists.txt in that subdirectory
add_subdirectory(src)

=== doc/CMakeLists.txt ===
# Doxygen related code
find_package(Doxygen)
if(DOXYGEN_FOUND)

  set(TAGFILES
    "${QT_DOC_DIR}/html/qt.tags=http://doc.qt.nokia.com/4.${QT_VERSION_MINOR}")
  set(TAGFILES
    "${TAGFILES} ${CMAKE_CURRENT_BINARY_DIR}/openbabel.tags=http://openbabel.org/api")

  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)

  # Write out a cmake script to download the Open Babel tag file
  file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/DownloadOBTag.cmake
"file(DOWNLOAD http://openbabel.org/api/openbabel.tags
  ${CMAKE_CURRENT_BINARY_DIR}/openbabel.tags SHOW_PROGRESS)")

  add_custom_target(download_ob_tagfile
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/DownloadOBTag.cmake)

  add_custom_target(doxygen
    COMMAND ${CMAKE_COMMAND} -E remove_directory ${CMAKE_CURRENT_BINARY_DIR}/api
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    DEPENDS download_ob_tagfile)
endif()

# find the required tools
find_program(DOCBOOK2PDF_EXECUTABLE docbook2pdf)
find_program(DOCBOOK2HTML_EXECUTABLE docbook2html)

if( DOCBOOK2PDF_EXECUTABLE AND DOCBOOK2HTML_EXECUTABLE )
   # create a target to build pdf docs
   add_custom_target(pdfdocs COMMAND ${DOCBOOK2PDF_EXECUTABLE} -o pdf
      ${CMAKE_CURRENT_SOURCE_DIR}/index.docbook )

   # create a target to build html docs
   add_custom_target(htmldocs COMMAND ${DOCBOOK2HTML_EXECUTABLE} -o html
      ${CMAKE_CURRENT_SOURCE_DIR}/index.docbook )

   # create a helper target to build both
   # if this is always wanted, the two custom targets above
   # can also be combined into one custom target with two COMMANDs
   #add_custom_target(alldocs ALL)
   add_custom_target(alldocs)
   add_dependencies(alldocs pdfdocs htmldocs)

   #FILE(GLOB avogadro_HTML RELATIVE ${CMAKE_CURRENT_BINARY_DIR}/html/ "*.html")
   #INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/pdf/index.pdf  DESTINATION share/doc/avogadro/pdf/ OPTIONAL)
   #INSTALL(FILES ${avogadro_HTML}  DESTINATION share/doc/avogadro/html/ OPTIONAL)

else( DOCBOOK2PDF_EXECUTABLE AND DOCBOOK2HTML_EXECUTABLE )
   message(STATUS "docbook tools not found, doc targets disabled")
endif( DOCBOOK2PDF_EXECUTABLE AND DOCBOOK2HTML_EXECUTABLE )

# Manpages
if(UNIX)
   file(GLOB man_1 *.1)
   install(FILES ${man_1} DESTINATION share/man/man1)
endif(UNIX)

=== libavogadro/CMakeLists.txt ===
project(libavogadro)
# Library versioning
# We probably want to adopt the libtool scheme once we hit 1.0.0
set(AVO_SOVERSION 1)

if(WIN32)
  add_definitions( -DWIN32 )
  # add definitions for OB in WIN32
  add_definitions( -DUSING_OBDLL -DUSING_DYNAMIC_LIBS )
endif()

# Provide a list of plugins that should be built statically, or ALL
set(Avogadro_STATIC_PLUGINS bsdyengine navigatetool elementcolor
  CACHE STRING
  "List of plugins to build statically (default is bsdyengine, elementcolor, navigatetool). Use ALL to build all plugins statically.")

# Create an empty variable to accumulate statically linked plugins in
set(plugins_built_static "" CACHE INTERNAL "Static Avogadro plugins")
set(plugins_rcc_static "" CACHE INTERNAL "Static resources for Avogadro plugins")

# Use this function to add a new plugin. It also uses the global variables
# LINK_LIBS to determine what libraries the plugin should link to and
# DESTINATION_DIR to determine where the plugin will be installed.
# ARGV2 is scanned for ui and or qrc files, ARGV3 is scanned for grc files
# in order to maintain compatibility.
function(avogadro_plugin_nogl plugin_name src_list)
  # Assume all MOC stuff is in the headers, replace .cpp and use qt4_wrap_cpp
  # Scan the header to verify the Q_OBJECT macro is used
  string(REPLACE ".cpp" ".h" hdr_list "${src_list}")
  set(moc_list "")
  foreach(file ${hdr_list})
    file(STRINGS "${file}" fileQObject REGEX "Q_OBJECT")
    if(fileQObject)
      list(APPEND moc_list "${file}")
    endif()
  endforeach()
  qt4_wrap_cpp(moc_files ${moc_list}
    OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED)
  # Now sort out the ui and qrc files, process them as appropriate
  set(ui_plugin_files)
  set(qrc_plugin_files)
  foreach(fileName ${ARGV2})
    if(${fileName} MATCHES "\\.qrc")
      set(qrc_plugin_files ${qrc_plugin_files} ${fileName})
    endif(${fileName} MATCHES "\\.qrc")
    if(${fileName} MATCHES "\\.ui")
      set(ui_plugin_files ${ui_plugin_files} ${fileName})
    endif(${fileName} MATCHES "\\.ui")
  endforeach()
  foreach(fileName ${ARGV3}) # Maintain compatibility with early function
    if(${fileName} MATCHES "\\.qrc")
      set(qrc_plugin_files ${qrc_plugin_files} ${fileName})
    endif()
  endforeach()
  if(NOT "${ui_plugin_files}" STREQUAL "")
    # Process the UI file for this plugin
    qt4_wrap_ui(plugin_UIS_H ${ui_plugin_files})
  endif()

  # Check if the plugin should be compiled static or not
  set(_plugin_type "MODULE")
  foreach(plugin ${Avogadro_STATIC_PLUGINS})
    if("${plugin}" STREQUAL "${plugin_name}" OR "${plugin}" STREQUAL "ALL")
      set(_plugin_type "STATIC")
      set(plugins_built_static ${plugins_built_static} ${plugin_name}
        CACHE INTERNAL "Static Avogadro plugins")
      break()
    endif()
  endforeach()

  if(NOT "${qrc_plugin_files}" STREQUAL "")
    # Process the RC file and add it to the plugin
    qt4_add_resources(plugin_RC_SRCS ${qrc_plugin_files})
    if("${_plugin_type}" STREQUAL "STATIC")
      set(plugins_rcc_static ${plugins_rcc_static} ${plugin_name}
        CACHE INTERNAL "Static resources for Avogadro plugins")
    endif()
  endif()

  add_library(${plugin_name} ${_plugin_type} ${src_list} ${moc_files}
              ${plugin_UIS_H} ${plugin_RC_SRCS})
  if("${_plugin_type}" STREQUAL "MODULE")
    install(TARGETS ${plugin_name} DESTINATION ${DESTINATION_DIR})
  else()
    # Needed to remove circular dependencies, will be linked to avogadro
    list(REMOVE_ITEM LINK_LIBS "avogadro")
    set_target_properties(${plugin_name} PROPERTIES
      COMPILE_FLAGS "-DQT_STATICPLUGIN ${CMAKE_SHARED_LIBRARY_CXX_FLAGS}")
  endif()
  target_link_libraries(${plugin_name} ${LINK_LIBS} ${QT_QTCORE_LIBRARY}
                        ${QT_QTGUI_LIBRARY} ${OPENBABEL2_LIBRARIES})
  set_target_properties(${plugin_name} PROPERTIES
                        OUTPUT_NAME ${plugin_name}
                        PREFIX ""
                        LABELS "${PLUGIN_LABEL}")
  # If we have set the PLUGIN_TARGET variable add this plugin to the custom
  # target. This assumes that the target was created before this function was
  # called.
  if(PLUGIN_TARGET)
    add_dependencies(${PLUGIN_TARGET} ${plugin_name})
  endif()
endfunction()

function(avogadro_plugin plugin_name src_list)
  avogadro_plugin_nogl("${plugin_name}" "${src_list}")
  target_link_libraries(${plugin_name} ${OPENGL_LIBRARIES} )
endfunction()

# tell cmake to process CMakeLists.txt in that subdirectory
add_subdirectory(src)

if(ENABLE_TESTS)
  add_subdirectory(tests)
endif()

=== avogadro/src/CMakeLists.txt ===
set(QT_USE_QTOPENGL true)
set(QT_USE_QTNETWORK true)

if(WIN32)
  set(QT_USE_QTMAIN true)
endif()

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/config.h
)

link_directories(${OPENBABEL2_LIBRARY_DIRS})

# Ensure the Avogadro include directory is always first
get_directory_property(tmp_include_dirs INCLUDE_DIRECTORIES)
set_directory_properties(PROPERTIES INCLUDE_DIRECTORIES
  "${libavogadro_BINARY_DIR}/include;${tmp_include_dirs}")
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${OPENBABEL2_INCLUDE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
)

if(EIGEN3_FOUND)
	include_directories(
		${EIGEN3_INCLUDE_DIR}
	)
elseif(EIGEN2_FOUND)
	include_directories(
		${EIGEN2_INCLUDE_DIR}
	)
endif(EIGEN3_FOUND)

if(GLEW_FOUND)
  include_directories(${GLEW_INCLUDE_DIR})
endif()

include(${QT_USE_FILE})

option(QtTesting "Enable Qt Testing framework?" OFF)
if(QtTesting)
  find_package(QtTesting REQUIRED)
  include_directories(${QtTesting_INCLUDE_DIRS})
  link_directories(${QtTesting_LIBRARY_DIR})
  add_definitions(-DQTTESTING)
endif()

FILE(GLOB avogadro_SRCS "*.cpp")

# Should we build the update checking code? Currently causes segfaults with Qt
# 4.5.3 on both Arch and Gentoo 64 bit platforms (may be more)
option(ENABLE_UPDATE_CHECKER
  "Should the Avogadro update checking code be compiled?" OFF)
if(ENABLE_UPDATE_CHECKER)
  add_definitions(-DENABLE_UPDATE_CHECKER)
else()
  list(REMOVE_ITEM avogadro_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/updatecheck.cpp")
  list(REMOVE_ITEM avogadro_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/updatedialog.cpp")
endif()

FILE(GLOB projectDelegates_SRCS "projectdelegates/*.cpp")
set(avogadro_SRCS ${avogadro_SRCS} ${projectDelegates_SRCS})

if(WIN32)
  set(avogadro_SRCS ${avogadro_SRCS} windows/avogadro.rc)
endif()

file(GLOB avogadro_RCS "*.qrc")

file(GLOB avogadro_UIS "*.ui")

# designer has some flaws.
qt4_automoc(${avogadro_SRCS})
qt4_add_resources(avogadro_RC_SRCS ${avogadro_RCS})
qt4_wrap_ui(avogadro_UIS_H ${avogadro_UIS})

if(NOT WIN32)
  if(Linguist_FOUND)
    file(GLOB_RECURSE lang_PO  "${Avogadro_SOURCE_DIR}/i18n/avogadro/*.po")
    foreach(po ${lang_PO})
      string(REGEX REPLACE "(.*)/([^.]+)\\.po" "\\1/avogadro-\\2.po" po ${po})
      list(APPEND avogadro_PO ${po})
    endforeach()
    QT4_WRAP_PO(avogadro_QM ${avogadro_PO})
  endif()
else()
  # don't attempt to create QM files on windows -- copy them from a linux build!
  file(GLOB_RECURSE avogadro_QM "${Avogadro_SOURCE_DIR}/avogadro/src/avogadro*.qm")
endif()

# Some relative rpath handling for Linux
if(UNIX AND ENABLE_RPATH AND NOT APPLE)
  # Set a relative rpath on Linux - just testing right now...
  set(CMAKE_INSTALL_RPATH "$ORIGIN/../lib${LIB_SUFFIX}")
endif()

add_executable(avogadro-app WIN32 MACOSX_BUNDLE
  ${avogadro_SRCS}
  ${avogadro_UIS_H}
  ${avogadro_RC_SRCS}
  ${avogadro_QM}
)

set_target_properties(avogadro-app PROPERTIES
  OUTPUT_NAME avogadro
  LABELS avogadro-app)
set_source_files_properties(${avogadro_SRCS}
  PROPERTIES LABELS avogadro)

target_link_libraries(avogadro-app
  ${QT_LIBRARIES}
  ${OPENBABEL2_LIBRARIES}
  avogadro)
if(QtTesting)
  target_link_libraries(avogadro-app QtTesting)
endif()
if(Q_WS_X11)
  find_package(X11 REQUIRED)
  target_link_libraries(avogadro-app ${X11_X11_LIB})
endif()

if(ENABLE_PYTHON)
  target_link_libraries(avogadro-app ${Boost_LIBRARIES})
endif()

if(ENABLE_UPDATE_CHECKER)
  target_link_libraries(avogadro-app ${QT_QTNETWORK_LIBRARY})
endif()

if(APPLE)
  set(MACOSX_BUNDLE_INFO_STRING "Avogadro - version ${Avogadro_VERSION_FULL}")
  set(MACOSX_BUNDLE_BUNDLE_VERSION ${Avogadro_VERSION_FULL})
  # Change following line to point to actual icns file in bundle.
  set(MACOSX_BUNDLE_ICON_FILE "avogadro.icns")
  # means bundle is set to be net.sourceforge.Avogadro
  set(MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge")
  set(MACOSX_BUNDLE_BUNDLE_NAME "Avogadro")

  set(CMAKE_INSTALL_DESTINATION_ARGS
      BUNDLE DESTINATION "${CMAKE_BUNDLE_LOCATION}")
  # This also sets the bundle name correctly
  set_target_properties(avogadro-app
    PROPERTIES OUTPUT_NAME "${CMAKE_BUNDLE_NAME}")

  # Use relative paths for the executable to link to its libraries
  set_target_properties(avogadro-app PROPERTIES
    CMAKE_INSTALL_NAME_DIR "@executable_path/../lib")

  set(MACOSX_SRC_DIR ${avogadro_SOURCE_DIR}/src/mac)

  # Overload the Info.plist default
  set(CMAKE_MODULE_PATH ${avogadro_SOURCE_DIR}/src/mac ${CMAKE_MODULE_PATH})

  # Do not install the bundle into the prefix - just everything else
  set(Avogadro_INSTALL_DESTINATIONS_ARGS
    BUNDLE DESTINATION "${CMAKE_BUNDLE_LOCATION}")

  install(FILES "mac/avogadro.icns" DESTINATION Resources)
  install(FILES "mac/AvogadroDocument.icns" DESTINATION Resources)

  # install .nib file
  set(QT_COCOA_NIB /Library/Frameworks/QtGui.framework/Versions/Current/Resources/qt_menu.nib)
  if(EXISTS ${QT_COCOA_NIB})
    install(DIRECTORY ${QT_COCOA_NIB}
      DESTINATION Resources
      USE_SOURCE_PERMISSIONS)
  endif()

# Install a .lproj directory for each translation
# We're assuming that there will never be an libavogadro translation
#  without a corresponding avogadro one.
# (Fairly safe assumption)

# This regex gives us translations with just two characters
#  (e.g., avogadro_fr.ts)
  string(REGEX MATCHALL "-[a-z]+\\.po" langresult "${avogadro_PO}")
  string(REGEX REPLACE "-([^.]+)\\.po" "\\1" languages "${langresult}")
# This one gives us languages for country codes (e.g., avogadro_zh_CN.ts)
  string(REGEX MATCHALL "-[a-z]+_[A-Z]+\\.po" langresult "${avogadro_PO}")
  string(REGEX REPLACE "-([^_]+_[^.]+)\\.po" "\\1" fulllangs "${langresult}")
  set (LANGUAGES "${languages};${fulllangs};en;en_US")

  foreach(lang ${LANGUAGES})
    set( MAC_LANG_DIR "${CMAKE_INSTALL_PREFIX}/Resources/${lang}.lproj" )
    install(CODE "EXECUTE_PROCESS(COMMAND
      mkdir ${MAC_LANG_DIR}
      ERROR_QUIET)")
    install(CODE "EXECUTE_PROCESS(COMMAND
      ${MACOSX_SRC_DIR}/lang.sh ${MACOSX_SRC_DIR} ${MAC_LANG_DIR} ${Avogadro_VERSION_FULL} ${lang}
      OUTPUT_QUIET)")
  endforeach()
endif()

install(TARGETS avogadro-app RUNTIME DESTINATION ${BIN_INSTALL_DIR}
  ${Avogadro_INSTALL_DESTINATIONS_ARGS})

install(FILES ${avogadro_QM} DESTINATION ${I18N_INSTALL_DIR})

if(APPLE AND ENABLE_AVO_PACKAGE)
  set(OSX_MAKE_STANDALONE_BUNDLE_CMAKE_SCRIPT
    "${CMAKE_BINARY_DIR}/Avogadro_OSX_MakeStandAloneBundle.cmake")
  set(OSX_MAKE_STANDALONE_BUNDLE_BASH_SCRIPT
    "${CMAKE_BINARY_DIR}/Avogadro_OSX_MakeStandAloneBundle.sh")
  # Configure the cmake file and the shell script
  configure_file("${MACOSX_SRC_DIR}/CompleteBundle.cmake.in"
    "${OSX_MAKE_STANDALONE_BUNDLE_CMAKE_SCRIPT}" @ONLY IMMEDIATE)
  configure_file("${MACOSX_SRC_DIR}/CreateBundle.sh.in"
    "${OSX_MAKE_STANDALONE_BUNDLE_BASH_SCRIPT}" @ONLY IMMEDIATE)
  install(SCRIPT "${OSX_MAKE_STANDALONE_BUNDLE_CMAKE_SCRIPT}")
endif()

# Install a .desktop file and icon for users of XDG-aware OSes
if(XDG_APPS_INSTALL_DIR AND XDG_ICON_INSTALL_DIR)
  install(FILES "avogadro.desktop" DESTINATION "${XDG_APPS_INSTALL_DIR}")
  install(FILES "icons/avogadro-icon.png" DESTINATION "${XDG_ICON_INSTALL_DIR}")
endif()

=== libavogadro/src/CMakeLists.txt ===
set(QT_USE_QTOPENGL true)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/config.h)

include(${QT_USE_FILE})

# Ensure the Avogadro include directory is always first
get_directory_property(tmp_include_dirs INCLUDE_DIRECTORIES)
set_directory_properties(PROPERTIES INCLUDE_DIRECTORIES
  "${libavogadro_BINARY_DIR}/include;${tmp_include_dirs}")
include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${OPENBABEL2_INCLUDE_DIR}
)

if(EIGEN3_FOUND)
	include_directories(
		${EIGEN3_INCLUDE_DIR}
	)
elseif(EIGEN2_FOUND)
	include_directories(
		${EIGEN2_INCLUDE_DIR}
	)
endif(EIGEN3_FOUND)

# I think this is necessary now in order to tell the linker where openbabel is
link_directories(${OPENBABEL2_LIBRARY_DIRS})

# Only headers with exported symbols should actually be installed
set(libavogadro_HDRS
  animation.h
  atom.h
  bond.h
  camera.h
  color3f.h
  colorbutton.h
  color.h
  ${CMAKE_CURRENT_BINARY_DIR}/config.h
  cube.h
  dockextension.h
  dockwidget.h
  elementtranslator.h
  engine.h
  extension.h
  fragment.h
  glhit.h
  global.h
  glwidget.h
  idlist.h
  meshgenerator.h
  mesh.h
  moleculefile.h
  molecule.h
  navigate.h
  neighborlist.h
  obeigenconv.h
  painterdevice.h
  painter.h
  periodictableview.h
  plotaxis.h
  plotobject.h
  plotpoint.h
  plotwidget.h
  plugin.h
  pluginmanager.h
  primitive.h
  primitivelist.h
  protein.h
  residue.h
  textmatrixeditor.h
  toolgroup.h
  tool.h
  undosequence.h
  zmatrix.h
)

set(libavogadro_SRCS
  animation.cpp
  atom.cpp
  bond.cpp
  camera.cpp
  color.cpp
  colorbutton.cpp
  cube.cpp
  cylinder_p.cpp
  dockextension.cpp
  dockwidget.cpp
  elementdetail_p.cpp
  elementitem_p.cpp
  elementtranslator.cpp
  engine.cpp
  extension.cpp
  fragment.cpp
  glhit.cpp
  global.cpp
  glpainter_p.cpp
  glwidget.cpp
  idlist.cpp
  mesh.cpp
  meshgenerator.cpp
  molecule.cpp
  moleculefile.cpp
  navigate.cpp
  neighborlist.cpp
  painter.cpp
  periodictablescene_p.cpp
  periodictableview.cpp
  plotaxis.cpp
  plotobject.cpp
  plotpoint.cpp
  plotwidget.cpp
  plugin.cpp
  pluginmanager.cpp
  primitive.cpp
  primitivelist.cpp
  protein.cpp
  readfilethread_p.cpp
  residue.cpp
  sphere_p.cpp
  textrenderer_p.cpp
  textmatrixeditor.cpp
  tool.cpp
  toolgroup.cpp
  undosequence.cpp
  zmatrix.cpp
)

set(libavogadro_MOC_HDRS
  animation.h
  atom.h
  bond.h
  color.h
  colorbutton.h
  cube.h
  dockextension.h
  dockwidget.h
  elementdetail_p.h
  elementtranslator.h
  engine.h
  extension.h
  fragment.h
  glwidget.h
  mesh.h
  meshgenerator.h
  molecule.h
  moleculefile.h
  periodictablescene_p.h
  periodictableview.h
  plotwidget.h
  plugin.h
  pluginmanager.h
  primitive.h
  protein.h
  readfilethread_p.h
  residue.h
  textmatrixeditor.h
  tool.h
  toolgroup.h
  zmatrix.h
)

set(AVO_LINK_LIBRARIES
  ${OPENBABEL2_LIBRARIES}
  ${QT_LIBRARIES}
  ${OPENGL_LIBRARIES}
)

if(GLEW_FOUND)
  include_directories(${GLEW_INCLUDE_DIR})
  list(APPEND AVO_LINK_LIBRARIES ${GLEW_LIBRARY})
endif()

# Library translations
if(NOT WIN32)
  if(Linguist_FOUND)
    file(GLOB_RECURSE lang_PO "${Avogadro_SOURCE_DIR}/i18n/libavogadro/*.po")
    foreach(po ${lang_PO})
      string(REGEX REPLACE "(.*)/([^.]+)\\.po" "\\1/libavogadro-\\2.po" po ${po})
      list(APPEND libavogadro_PO ${po})
    endforeach()
    QT4_WRAP_PO(libavogadro_QM ${libavogadro_PO})
  endif()
else()
  # don't attempt to create QM files on windows -- copy them from a linux build!
  file(GLOB_RECURSE libavogadro_QM
    "${Avogadro_SOURCE_DIR}/libavogadro/src/libavogadro*.qm")
endif()

# you have to add link_directories before you add the target
if(ENABLE_PYTHON AND ALL_PYTHON_FOUND)
  message(STATUS "Setting new boost python libraries")
  include_directories(
    ${Boost_INCLUDE_DIRS}
    ${PYTHON_INCLUDE_PATH})
  qt4_add_resources(pythontool_RC_SRCS pythontool.qrc)
  list(APPEND AVO_LINK_LIBRARIES ${PYTHON_LIBRARIES} ${Boost_LIBRARIES})
  list(APPEND libavogadro_HDRS
    pythoninterpreter.h
    pythonscript.h
    pythonerror.h)
  list(APPEND libavogadro_MOC_HDRS
    pythonengine_p.h
    pythonerror.h
    pythonextension_p.h
    pythontool_p.h)
  list(APPEND libavogadro_SRCS
    pythoninterpreter.cpp
    pythonscript.cpp
    pythonerror.cpp
    pythontool_p.cpp
    pythonengine_p.cpp
    pythonextension_p.cpp)
endif()

qt4_wrap_cpp(libavogadro_MOC ${libavogadro_MOC_HDRS}
  OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED)

# Set up the include directory and symlink/copy all headers to it.
# Note: Windows lacks symlinks and so the files must be copied.
make_directory("${libavogadro_BINARY_DIR}/include/avogadro")
if(UNIX)
  set(header_cmd "create_symlink")
else()
  set(header_cmd "copy_if_different")
endif()
foreach(headerFile ${libavogadro_HDRS})
  set(from "${CMAKE_CURRENT_SOURCE_DIR}/${headerFile}")
  set(to   "${libavogadro_BINARY_DIR}/include/avogadro/${headerFile}")
  execute_process(COMMAND ${CMAKE_COMMAND} -E ${header_cmd} "${from}" "${to}")
endforeach()

add_library(avogadro SHARED
  ${libavogadro_SRCS}
  ${libavogadro_MOC}
  ${libavogadro_QM}
  ${pythontool_RC_SRCS})
set_target_properties(avogadro PROPERTIES
  VERSION ${Avogadro_VERSION_FULL}
  LINK_INTERFACE_LIBRARIES ""
  SOVERSION ${AVO_SOVERSION}
  LABELS avogadro)
install(FILES ${libavogadro_HDRS}
  DESTINATION "${INCLUDE_INSTALL_DIR}/avogadro")
install(TARGETS avogadro DESTINATION ${LIB_INSTALL_DIR} EXPORT AvogadroTargets)

# Add the engiens, tools and extensions directories
add_subdirectory(engines)
add_subdirectory(tools)
add_subdirectory(extensions)
add_subdirectory(colors)

set(static_plugin_instantiation "#include <QtCore/QCoreApplication>\n")
foreach(plugin ${plugins_built_static})
  set(static_plugin_instantiation "${static_plugin_instantiation}
Q_IMPORT_PLUGIN(${plugin})")
endforeach()
set(static_plugin_instantiation "${static_plugin_instantiation}
void initAvogadroResources()
{
")
foreach(plugin ${plugins_rcc_static})
  set(static_plugin_instantiation "${static_plugin_instantiation}
Q_INIT_RESOURCE(${plugin});")
endforeach()
set(static_plugin_instantiation "${static_plugin_instantiation}
}
")
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/staticplugins.cpp.in
  "${static_plugin_instantiation}\n")
configure_file(${CMAKE_CURRENT_BINARY_DIR}/staticplugins.cpp.in
  ${CMAKE_CURRENT_BINARY_DIR}/staticplugins.cpp)

target_link_libraries(avogadro ${AVO_LINK_LIBRARIES} ${plugins_built_static})
message(STATUS "Linking in static plugins: ${plugins_built_static}")
# Add the boost python module if the boost::python was found
if(ENABLE_PYTHON AND ALL_PYTHON_FOUND)
  add_subdirectory(python)
endif()

install(FILES ${libavogadro_QM} DESTINATION ${I18N_INSTALL_DIR})

if(NOT APPLE)
  install(EXPORT AvogadroTargets DESTINATION ${LIB_INSTALL_DIR}/avogadro)
endif()

=== libavogadro/examples/c++/CMakeLists.txt ===
######################################################################
# Example CMake project building a 3rd party extension against 
# installed Avogadro library.  
# See http://avogadro.cc/ for more information.
######################################################################

# Project name - plugin name or something meaningful
project(TemplateExtension)

# Minimum version of CMake that can be used
cmake_minimum_required(VERSION 2.6)

# Find the Avogadro library if it is installed
find_package(Avogadro REQUIRED)
 
set(QT_MIN_VERSION "4.5.0")
find_package(Qt4 REQUIRED)

# Activate this line if you need direct use of OpenBabel
#find_package(OpenBabel2 REQUIRED)

# Set up the build environment
include(${Avogadro_USE_FILE})
include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${OPENBABEL2_INCLUDE_DIR}
)
link_directories(${OPENBABEL2_LIBRARY_DIRS})

# Build your plugin using the default options
set (templateextension_SRCS templateextension.cpp)

avogadro_plugin(templateextension "${templateextension_SRCS}")

=== libavogadro/src/colors/CMakeLists.txt ===
include(${QT_USE_FILE})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_SHARED)

set(DESTINATION_DIR ${Avogadro_PLUGIN_INSTALL_DIR}/colors)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(LINK_LIBS avogadro)
set(PLUGIN_LABEL colors)
set(PLUGIN_TARGET colors)
add_custom_target(colors COMMENT "Meta target to build all Avogadro colors.")

### elementcolor
avogadro_plugin(elementcolor elementcolor.cpp)

### residuecolor
avogadro_plugin(residuecolor residuecolor.cpp residuecolorsettings.ui)

### indexcolor
avogadro_plugin(atomindexcolor atomindexcolor.cpp)

### chargecolor
avogadro_plugin(chargecolor chargecolor.cpp)

### distancecolor
avogadro_plugin(distancecolor distancecolor.cpp)

## custom color
avogadro_plugin(customcolor customcolor.cpp)

## smartscolor
avogadro_plugin(smartscolor smartscolor.cpp)

=== libavogadro/src/engines/CMakeLists.txt ===
include(${QT_USE_FILE})

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(DESTINATION_DIR ${Avogadro_PLUGIN_INSTALL_DIR}/engines)

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_SHARED)

link_directories(${CMAKE_CURRENT_BINARY_DIR}/..)

set(LINK_LIBS avogadro)
set(PLUGIN_LABEL engines)
set(PLUGIN_TARGET engines)
add_custom_target(engines COMMENT "Meta target to build all Avogadro engines.")

# ball and stick engine
avogadro_plugin(bsdyengine bsdyengine.cpp bsdysettingswidget.ui)

# label engine
avogadro_plugin(labelengine labelengine.cpp labelsettingswidget.ui)

# wireframe
avogadro_plugin(wireengine wireengine.cpp wiresettingswidget.ui)

# hydrogen bond
avogadro_plugin(hbondengine hbondengine.cpp hbondsettingswidget.ui)

# force engine
avogadro_plugin(forceengine forceengine.cpp)
if(${CMAKE_CXX_COMPILER_ID} MATCHES Intel AND UNIX)
  set_target_properties(forceengine PROPERTIES COMPILE_FLAGS "-fvisibility=default")
endif()

# sphere
avogadro_plugin(sphereengine sphereengine.cpp spheresettingswidget.ui)

# stick (cylinder) engine
avogadro_plugin(stickengine stickengine.cpp sticksettingswidget.ui)

# Ribbon engine (biological structure)
avogadro_plugin(ribbonengine ribbonengine.cpp ribbonsettingswidget.ui)

# Cartoon engine (biological structure)
avogadro_plugin(cartoonengine "cartoonengine.cpp;cartoonmeshgenerator.cpp" cartoonsettingswidget.ui)

# Ring engine - display cyclic rings
avogadro_plugin(ringengine ringengine.cpp ringsettingswidget.ui)

# Polygon engine
avogadro_plugin(polygonengine polygonengine.cpp)

# Surface engine - molecular surfaces and 3D functions
avogadro_plugin(surfaceengine surfaceengine.cpp surfacesettingswidget.ui)

# Axes engine - display the axes
avogadro_plugin(axesengine axesengine.cpp axessettingswidget.ui)

# Dipole engine -- dipole moment
avogadro_plugin(dipoleengine dipoleengine.cpp dipolesettingswidget.ui)

# Simple wire engine - designed for efficiency with really big systems
avogadro_plugin(simplewireengine simplewireengine.cpp)

# QTAIM engine - Quantum Theory of Atoms In Molecules
avogadro_plugin(qtaimengine qtaimengine.cpp qtaimsettingswidget.ui)

if(ALL_PYTHON_FOUND)
  file(GLOB python_SCRIPTS "python/*.py")
  install(FILES ${python_SCRIPTS} DESTINATION share/libavogadro/engineScripts)
endif()

=== libavogadro/src/extensions/CMakeLists.txt ===
ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_SHARED)

set(DESTINATION_DIR ${Avogadro_PLUGIN_INSTALL_DIR}/extensions)

include_directories(${CMAKE_CURRENT_BINARY_DIR}
  "${CMAKE_CURRENT_SOURCE_DIR}/gl2ps"
)

set(LINK_LIBS avogadro)
set(PLUGIN_LABEL extensions)
set(PLUGIN_TARGET extensions)
add_custom_target(extensions COMMENT "Meta target to build all Avogadro extensions.")

### Template extension - template for extensions
#avogadro_plugin(templateextension templateextension.cpp)

### Properties
avogadro_plugin_nogl(propextension
  "../tools/skeletontree.cpp;propmodel.cpp;propextension.cpp")

avogadro_plugin_nogl(cartesianextension
  cartesianextension.cpp
  cartesianeditor.ui
  cartesianextension.qrc)

avogadro_plugin_nogl(molecularpropextension
  molecularpropextension.cpp
  molecularpropdialog.ui)
target_link_libraries(molecularpropextension ${QT_QTNETWORK_LIBRARY})

### Molecular Mechanics force fields
set(forcefieldextension_SRCS forcefieldextension.cpp forcefielddialog.cpp
  constraintsdialog.cpp constraintsmodel.cpp conformersearchdialog.cpp)
avogadro_plugin_nogl(forcefieldextension
  "${forcefieldextension_SRCS}"
  "forcefielddialog.ui;constraintsdialog.ui;conformersearchdialog.ui")
if(${CMAKE_CXX_COMPILER_ID} MATCHES Intel AND UNIX)
  set_target_properties(forcefieldextension PROPERTIES COMPILE_FLAGS "-fvisibility=default")
endif()

### hydrogens
avogadro_plugin_nogl(hydrogensextension hydrogensextension.cpp)

### invertchirality
avogadro_plugin_nogl(invertchiralextension invertchiralextension.cpp)

### Selections
avogadro_plugin_nogl(selectextension selectextension.cpp)

### insert fragment
avogadro_plugin_nogl(insertfragmentextension
  "insertfragmentextension.cpp;insertfragmentdialog.cpp;insertcommand.cpp;sortfiltertreeproxymodel.cpp"
  insertfragmentdialog.ui)

### insert peptide (builder)
avogadro_plugin_nogl(insertpeptideextension
  "insertpeptideextension.cpp;insertcommand.cpp"
  insertpeptidedialog.ui)

### insert dna (builder)
avogadro_plugin_nogl(insertdnaextension
  "insertdnaextension.cpp;insertcommand.cpp"
  insertdnadialog.ui)

### h->methyl
avogadro_plugin_nogl(h2methylextension h2methylextension.cpp)

if(ENABLE_PYTHON AND ALL_PYTHON_FOUND)
  ### python terminal
  message(STATUS "Enabled python terminal")
  avogadro_plugin_nogl(pythonterminal
    "pythonterminal.cpp;highlighter.cpp"
    pythonterminalwidget.ui)
  target_link_libraries(pythonterminal ${PYTHON_LIBRARIES})

  file(GLOB python_SCRIPTS "python/*.py")
  install(FILES ${python_SCRIPTS} DESTINATION share/libavogadro/extensionScripts)
endif()

### Animation
set(animationextension_SRCS animationextension.cpp animationdialog.cpp
  povpainter.cpp trajvideomaker.cpp)
avogadro_plugin_nogl(animationextension
  "${animationextension_SRCS}"
  animationdialog.ui
  animationextension.qrc)

### POV-Ray extension
avogadro_plugin_nogl(povrayextension
  "povrayextension.cpp;povpainter.cpp;povraydialog.cpp"
  povraydialog.ui)

### VRML export extension
avogadro_plugin_nogl(vrmlextension
  "vrmlextension.cpp;vrmlpainter.cpp;vrmldialog.cpp"
  vrmldialog.ui)

### File import extension
avogadro_plugin_nogl(fileimportextension fileimportextension.cpp fileimportdialog.ui)

### Shader extension
if(GLEW_FOUND)
  avogadro_plugin(shaderextension
    shaderextension.cpp
    shaderdialog.ui)
  target_link_libraries(shaderextension ${GLEW_LIBRARY})
  file(GLOB shader_VERT "shaders/*.vert")
  file(GLOB shader_FRAG "shaders/*.frag")
  file(GLOB shader_PARAMS "shaders/*.params")
  install(FILES ${shader_VERT} ${shader_FRAG} ${shader_PARAMS}
    DESTINATION share/libavogadro/shaders)
endif()

### super cells
avogadro_plugin_nogl(supercellextension
  "supercellextension.cpp;supercelldialog.cpp"
  supercelldialog.ui)

# Network fetch
avogadro_plugin_nogl(networkfetchextension networkfetchextension.cpp)
target_link_libraries(networkfetchextension ${QT_QTNETWORK_LIBRARY})

# GL2PS
avogadro_plugin(gl2psextension
  "gl2psextension.cpp;gl2ps/gl2ps.c")

# Symmetry (libmsym) has compile issues on Windows
# due to VLA not supported by C compiler
if (MSVC)
  OPTION(BUILD_SYMMETRY "Build symmetry extension and libmsym - not supported with Visual Studio" OFF)
else()
  OPTION(BUILD_SYMMETRY
  "Build symmetry extension and libmsym" ON)
endif()

if(BUILD_SYMMETRY)
  add_subdirectory(symmetry)
endif()

# Subdirs
add_subdirectory(crystallography)
add_subdirectory(spectra)
add_subdirectory(surfaces)
add_subdirectory(swcntbuilder)
add_subdirectory(qtaim)
add_subdirectory(quantuminput)
add_subdirectory(orca)

=== libavogadro/examples/thirdPartyExtensions/01-HelloWorld/CMakeLists.txt ===
# Hello World Avogadro extension.
# See http://avogadro.cc/ for more information.

# Project name
project(HelloWorldExtension)

# Minimum version of CMake that can be used
cmake_minimum_required(VERSION 2.6)

# Set up Qt
set(QT_MIN_VERSION "4.5.0")
find_package(Qt4 REQUIRED)

# Set up Avogadro
find_package(Avogadro REQUIRED)
include(${Avogadro_USE_FILE})

# Specify include directories
include_directories(
  # Needed to include Qt moc'd headers
  ${CMAKE_CURRENT_BINARY_DIR}
)

# Create a list of all source files
set( helloworldextension_SRCS
     helloworldextension.cpp
     helloworlddialog.cpp
)

# Create a list of all ui files
set( helloworldextension_UIS
     helloworlddialog.ui
)

# Create the extension target helloworldextension
avogadro_plugin(helloworldextension "${helloworldextension_SRCS}" "${helloworldextension_UIS}")

=== libavogadro/examples/thirdPartyExtensions/02-DynamicDisplay/CMakeLists.txt ===
# Dynamic Display Avogadro extension.
# See http://avogadro.cc/ for more information.

# Project name
project(DynamicDisplayExtension)

# Minimum version of CMake that can be used
cmake_minimum_required(VERSION 2.6)

set(QT_MIN_VERSION "4.5.0")
find_package(Qt4 REQUIRED)
find_package(Avogadro REQUIRED)
include(${Avogadro_USE_FILE})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set( dynamicdisplayextension_SRCS
     dynamicdisplayextension.cpp
     dynamicdisplaydialog.cpp
)

set( dynamicdisplayextension_UIS
     dynamicdisplaydialog.ui
)

avogadro_plugin( dynamicdisplayextension
                 "${dynamicdisplayextension_SRCS}"
		 "${dynamicdisplayextension_UIS}")

=== debian/changelog ===
avogadro (1.2.0-1+deb9u1) stretch; urgency=medium

  [ Anton Gladky ]
  * Update eigen3 patches, pull them from upstream. (Closes: #865085)

 -- Michael Banck <mbanck@debian.org>  Thu, 13 Jul 2017 10:15:00 +0200

avogadro (1.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Merge with experimental.
  * debian/patches/nwchem_input_ccsd.patch: Removed, no longer needed.
  * debian/patches/hurd_ftbfs.patch: Likewise.
  * debian/patches/use_python_include_dirs.patch: Likewise.
  * debian/patches/fix_build_failure.patch: Likewise.
  * debian/patches/libmsymfloat.patch: New patch, fixes a build failure, taken
    from upstrem issue #836 by Henrique Junior.
  * debian/patches/boost148.patch: Updated.
  * debian/patches/link_to_libgl2ps.patch: Likewise.
  * debian/patches/probe-X11-paths-with-find_package.patch: Refreshed.
  * debian/patches/eigen3.patch: Updated, taken from upstream pull request #38.

 -- Michael Banck <mbanck@debian.org>  Sun, 02 Oct 2016 10:13:37 +0200

avogadro (1.1.1-1~exp6) experimental; urgency=medium

  * debian/rules (override_dh_strip): Removed target.

 -- Michael Banck <mbanck@debian.org>  Sun, 25 Sep 2016 14:27:43 +0200

avogadro (1.1.1-1~exp5) experimental; urgency=medium

  * debian/changelog: Merge changes from unstable.
  * debian/control: Likewise.

 -- Michael Banck <mbanck@debian.org>  Sun, 25 Sep 2016 11:52:06 +0200

avogadro (1.1.1-1~exp4) experimental; urgency=medium

  * debian/patches/fix-qreal-vs-double.patch: New patch, fixes qreal VS double
    issue, by Peter Green. (Closes: #838733)

 -- Michael Banck <mbanck@debian.org>  Sun, 25 Sep 2016 11:05:55 +0200

avogadro (1.0.3-14) unstable; urgency=medium

  * Acknowledge NMU.
  * debian/patches/boost148.patch: Updated with further hunks skipping
    inclusion of <boost/python.hpp> during MOC runs (Closes: #833770).
  * debian/patches/fix_build_failure.patch: New patch, fixes a build failure,
    taken from the 1.2.0 release.

 -- Michael Banck <mbanck@debian.org>  Sat, 24 Sep 2016 14:57:50 +0200

avogadro (1.1.1-1~exp3.1) experimental; urgency=medium

  * Non-maintainer upload.
  * "Fix" GCC version check up to GCC 9. Closes: #812265.

 -- Matthias Klose <doko@debian.org>  Thu, 04 Aug 2016 19:06:58 +0200

avogadro (1.0.3-13.1) unstable; urgency=medium

  * Non-maintainer upload.
  * "Fix" GCC version check up to GCC 9. Closes: #812265.

 -- Matthias Klose <doko@debian.org>  Tue, 02 Aug 2016 11:46:17 +0200

avogadro (1.0.3-13) unstable; urgency=medium

  * Add myself to uploaders.
  * Update eigen3-patch. Drop EIGEN2_SUPPORT.

 -- Anton Gladky <gladk@debian.org>  Sun, 27 Sep 2015 07:56:31 +0200

avogadro (1.0.3-12) unstable; urgency=medium

  * debian/control (libavogadro-dev/Depends): Replaced libeigen2-dev by
    libeigen3-dev.
  * debian/upstream: Move to ...
  * debian/upstream/metadata: ... here.
  * debian/control (Standards-Version): Bumped to 3.9.6.

 -- Michael Banck <mbanck@debian.org>  Fri, 18 Sep 2015 09:57:47 +0200

avogadro (1.0.3-11) unstable; urgency=medium

  * debian/upstream: Added eprint URL.
  * Acknowledge NMU.
  * debian/patches/probe-X11-paths-with-find_package.patch: New patch, fixes
    cmake no longer automatically doing X11 detection, adopted from a patch by
    Andy Whitcroft (Closes: #790859).

 -- Michael Banck <mbanck@debian.org>  Thu, 17 Sep 2015 12:50:24 +0200

avogadro (1.1.1-1~exp3) experimental; urgency=medium

  * [030ee70] Fix eigen3 dependency.

 -- Anton Gladky <gladk@debian.org>  Sun, 13 Sep 2015 15:29:38 +0200

avogadro (1.1.1-1~exp2) experimental; urgency=medium

  * [ff93007] Use eigen3 >>3.3.

 -- Anton Gladky <gladk@debian.org>  Sun, 13 Sep 2015 13:42:01 +0200

avogadro (1.1.1-1~exp1) experimental; urgency=medium

  * Team upload.
  * Fix compilation against eigen3.3. (Closes: #786355)
    Thanks to Kirill Okhotnikov for assistance.
  * Use libeigen3-dev instead of libeigen2-dev. (Closes: #776914)
  * Merge Ubuntu-changes.

 -- Anton Gladky <gladk@debian.org>  Wed, 09 Sep 2015 20:38:14 +0200

avogadro (1.0.3-10.1) unstable; urgency=low

  * Non-maintainer upload.
  * Replace eigen2 by eigen3. (Closes: #728610)

 -- Anton Gladky <gladk@debian.org>  Sun, 03 Nov 2013 16:28:19 +0100

avogadro (1.0.3-10) unstable; urgency=low

  [ Daniel Leidert ]
  * debian/rules (override_dh_auto_configure): Drop setting of
    -DPYTHON_INCLUDE_DIRS. This didn't work on other architectures than amd64.
  * debian/patches/series: Don't use the use_python_include_dirs.patch patch.

 -- Debichem Team <debichem-devel@lists.alioth.debian.org>  Sun, 02 Jun 2013 14:55:17 +0200

avogadro (1.0.3-9) unstable; urgency=low

  [ Daniel Leidert ]
  * debian/rules (override_dh_auto_configure): Try to fix the recently
    introduced FTBFSes (really closes: #710703).
  * debian/patches/use_python_include_dirs.patch: Reverted to 1.0.3-7.

 -- Debichem Team <debichem-devel@lists.alioth.debian.org>  Sun, 02 Jun 2013 02:30:46 +0200

avogadro (1.0.3-8) unstable; urgency=low

  [ Daniel Leidert ]
  * debian/control (Vcs-Browser, Vcs-Svn): Fixed vcs-field-not-canonical.
  * debian/rules: Try to fix an FTBFS if several Python versions are installed
    (closes: Bug#710703) and don't FTBFS if there is no multi-arch Python.
  * debian/patches/use_python_include_dirs.patch: Updated.
    - Removed patch to cmake/modules/PythonDeps.cmake.

 -- Debichem Team <debichem-devel@lists.alioth.debian.org>  Sat, 01 Jun 2013 23:28:47 +0200

avogadro (1.0.3-7) unstable; urgency=low

  [ Daniel Leidert ]
  * Ack NMU.
  * debian/rules: Prepare for Python multiarch.
    (override_dh_auto_configure): Adjusted likewise.
  * debian/patches/use_python_include_dirs.patch: Enabled (closes: #708639).
  * debian/patches/series: Adjusted.

 -- Debichem Team <debichem-devel@lists.alioth.debian.org>  Thu, 30 May 2013 00:04:44 +0200

avogadro (1.0.3-6.1) unstable; urgency=low

  * Non maintainer upload.
  * Fix to build with the libpython multiarch location.



=== debian/control ===
Source: avogadro
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>,
           Anton Gladky <gladk@debian.org>
Build-Depends: cmake (>> 2.6.0),
               debhelper (>> 7.0.50~),
               libboost-python-dev,
               libeigen3-dev (>> 3.3),
               libgl2ps-dev,
               libglew-dev,
               libopenbabel-dev (>> 2.2.0),
               libqt4-dev (>> 4.5.0),
               libqt4-opengl-dev,
               pkg-config,
               python (>> 2.6.6-3~),
               python-dev,
               python-numpy (>> 1:1.4.1-4~),
               python-sip-dev,
               qt4-dev-tools,
               zlib1g-dev
Standards-Version: 3.9.6
X-Python-Version: current
Homepage: http://avogadro.sourceforge.net/
Vcs-Browser: http://anonscm.debian.org/viewvc/debichem/unstable/avogadro/
Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/avogadro/

Package: avogadro
Architecture: any
Depends: libavogadro1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: avogadro-data (>= 1.0.0-2)
Description: Molecular Graphics and Modelling System
 Avogadro is a molecular graphics and modelling system targeted at molecules
 and biomolecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 Features include:
  * Molecular modeller with automatic force-field based geometry optimization
  * Molecular Mechanics including constraints and conformer searches
  * Visualization of molecular orbitals and general isosurfaces
  * Visualization of vibrations and plotting of vibrational spectra
  * Support for crystallographic unit cells
  * Input generation for the Gaussian, GAMESS and MOLPRO quantum chemistry
    packages
  * Flexible plugin architecture and Python scripting
 .
 File formats Avogadro can read include PDB, XYZ, CML, CIF, Molden, as well as
 Gaussian, GAMESS and MOLPRO output.

Package: avogadro-data
Architecture: all
Depends: ${misc:Depends}
Breaks: avogadro (<< 1.0.0-2), libavogadro0 (<< 1.0.0-2)
Replaces: avogadro (<< 1.0.0-2), libavogadro0 (<< 1.0.0-2)
Description: Molecular Graphics and Modelling System (Data Files)
 Avogadro is a molecular graphics and modelling system targeted at molecules
 and biomolecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package contains data files like molecular builder fragments or
 OpenGL shaders.

Package: libavogadro1
Conflicts: libavogadro0
Replaces: libavogadro0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: avogadro-data (>= 1.0.0-2), python-avogadro
Description: Molecular Graphics and Modelling System (library)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the shared library.

Package: libavogadro-dev
Architecture: any
Section: libdevel
Priority: extra
Depends: libavogadro1 (= ${binary:Version}),
         libeigen3-dev,
         libglew-dev,
         libopenbabel-dev (>= 2.2.0),
         libqt4-dev (>= 4.4.0),
         ${misc:Depends}
Description: Molecular Graphics and Modelling System (development files)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the development and header files.

Package: python-avogadro
Architecture: any
Section: python
Priority: extra
XB-Python-Version: ${python:Versions}
Depends: python-numpy,
         python-qt4,
         python-sip,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
         ${sip:Depends}
Replaces: libavogadro0 (<< 0.9.8)
Breaks: libavogadro0 (<< 0.9.8)
Provides: ${python:Provides}
Description: Molecular Graphics and Modelling System (Python module)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the Python module.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) -fPIC
export CFLAGS   := $(CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := $(CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS  := -fPIC $(shell dpkg-buildflags --get LDFLAGS) -Wl,-z,defs -Wl,--as-needed

DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
PYTHON_VERSION     := $(shell pyversions -dv)

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/libpython$(PYTHON_VERSION).so),)
PYTHON_LIBRARY=/usr/lib/$(DEB_HOST_MULTIARCH)/libpython$(PYTHON_VERSION).so
else
PYTHON_LIBRARY=/usr/lib/libpython$(PYTHON_VERSION).so
endif

%:
	dh $@ --with python2 --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DENABLE_GLSL=ON \
	-DENABLE_RPATH=OFF \
	-DENABLE_UPDATE_CHECKER=OFF \
	-DPYTHON_EXECUTABLE=/usr/bin/python$(PYTHON_VERSION) \
	-DPYTHON_LIBRARY=$(PYTHON_LIBRARY) \
	-DPYTHON_INCLUDE_DIR=/usr/include/python$(PYTHON_VERSION)/

override_dh_install:
	dh_install --list-missing

override_dh_clean:
	dh_clean conf.log conf.pri

override_dh_python2:
	dh_python2 -ppython-avogadro
	dh_numpy -ppython-avogadro
	dh_sip

=== debian/watch ===
# See uscan(1) for format

version=3
opts=uversionmangle=s/_(rc\d+)/~\1/g \
http://sf.net/avogadro/avogadro-([\d.]+(?:_rc\d+)?)\.tar\.(?:bz2|gz)
